﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace HamiltoninaGSD
{
    enum CycleStepResult
    {
        AddedNode, CompletedCycle, Failed, Continue
    }

    class BFSNode
    {


        protected int mIndex;
        protected int mDistance;
        protected int mBFSParent;
        protected int mBFSCounter;
        protected int mBFSTreeRoot;
        protected int mBFSTreeRootParent;
        protected bool mFinished;
        protected bool mAvailable;
        protected bool mInCycle;
        protected int mEarIndex;

        protected List<int> mBFSDescendants;



        public List<int> BFSDescendants
        {

            get { return mBFSDescendants; }
            set { mBFSDescendants = value; }
        }


        public bool BFSInCycle
        {

            get { return mInCycle; }
            set { mInCycle = value; }
        }


        public bool BFSFinished
        {

            get { return mFinished; }
            set { mFinished = value; }
        }

        public bool BFSAvailable
        {

            get { return mAvailable; }
            set { mAvailable = value; }
        }



        public int Index
        {

            get { return mIndex; }
            set { mIndex = value; }
        }

        public int EarIndex
        {

            get { return mEarIndex; }
            set { mEarIndex = value; }
        }

        public int BFSCounter
        {

            get { return mBFSCounter; }
            set { mBFSCounter = value; }
        }
        public int BFSTreeRoot
        {

            get { return mBFSTreeRoot; }
            set { mBFSTreeRoot = value; }
        }
        public int BFSTreeRootParent
        {

            get { return mBFSTreeRootParent; }
            set { mBFSTreeRootParent = value; }
        }


        public int BFSDistance
        {

            get { return mDistance; }
            set { mDistance = value; }
        }
        public int BFSParent
        {

            get { return mBFSParent; }
            set { mBFSParent = value; }
        }

        public BFSNode(BFSNode A)
        {

            mIndex = A.mIndex;
            mDistance = A.mDistance;
            mBFSParent = A.mBFSParent;
            mBFSCounter = A.mBFSCounter;
            mInCycle = A.mInCycle;
            mAvailable = A.mAvailable;
            mFinished = A.mFinished;
            mBFSTreeRoot = A.mBFSTreeRoot;
            mEarIndex = A.mEarIndex;
            mBFSDescendants = new List<int>();

            foreach (int desc in A.BFSDescendants)
            {

                mBFSDescendants.Add(desc);
            }

        }
        public BFSNode(int nIndex)
        {

            mIndex = nIndex;
            mDistance = 0;
            mBFSParent = -1;
            mBFSCounter = -1;
            mInCycle = false;
            mAvailable = true;
            mFinished = false;
            mBFSTreeRoot = -1;
            mEarIndex = -1;
            mBFSDescendants = new List<int>();
        }

        public BFSNode()
        {

            mIndex = -1;
            mDistance = -1;
            mBFSParent = -1;
            mBFSCounter = -1;
            mInCycle = false;
            mAvailable = true;
            mFinished = false;
            mBFSTreeRoot = -1;
            mEarIndex = -1;
            mBFSDescendants = new List<int>();
        }



        public BFSNode(int nIndex, int nBFSIndex, int nDistance)
        {

            mIndex = nIndex;
            mDistance = nDistance;
            mBFSParent = -1;
            mBFSCounter = nBFSIndex;
        }

        public BFSNode(int Index, int nBFSIndex, int Distance, int nParent)
        {

            mIndex = Index;
            mDistance = Distance;
            mBFSParent = nParent;
            mBFSCounter = nBFSIndex;
        }

    }
   




    
}
