﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.IO;

namespace HamiltoninaGSD
{
    public class ABSGraph
    {
        protected int mNumberOfVertices;
        protected int mNumberOfEdges;

        //  protected bool[,] mEdges;

        protected List<int>[] mEdges;
        
        public int NumberOfVertices {

            get{ return mNumberOfVertices; }
            set { mNumberOfVertices = value; CreateEdgeArray(); }
                
        }

        public int NumberOfEdges
        {

            get { return mNumberOfEdges; }
//            set { mNumberOfEdges = value; CreateEdgeArray(); }

        }

        public void RemoveEdge(int u, int v) { mEdges[u].Remove(v); mEdges[v].Remove(u); } 
    

        public void CreateEdgeArray() {

            mEdges = new List<int>[mNumberOfVertices];
            for (int i = 0; i < mNumberOfVertices; i++)
            {
                
                mEdges[i] = new List<int>();
            }
        }
        public ABSGraph(int nNumberOfVertex){

            mNumberOfVertices = nNumberOfVertex;
            mNumberOfEdges = 0;
            CreateEdgeArray();
            
        
        }

        public ABSGraph()
        {

            mNumberOfVertices = 50;
            mNumberOfEdges = 0;
            CreateEdgeArray();


        }
        public ABSGraph(ABSGraph A) 
        {


            mNumberOfVertices = A.mNumberOfVertices;
            mNumberOfEdges = 0;

            mEdges = new List<int>[mNumberOfVertices];

            /*
            for (int i = 0; i < A.NumberOfVertices; i++)
            {
                mEdges[i] = new List<int>(A.mEdges[i]);
            }
            */

                

                //CreateEdgeArray();




                for (int i = 0; i < A.NumberOfVertices; i++)
                {

                    mEdges[i] = (A.mEdges[i]).ToList();

//                mEdges[i] = (A.mEdges[i]).Clone();
    //                foreach (int v in A.mEdges[i])
    //                    AddEdge(i, v);

                }
    


            }


        

        public void GenerateRandomBiConnected(int n, int m, int Seed)
        {

                int[] lSelectNode = new int[3];
                 
                int counter = 0;
                if (n < 3) n = 3;
                if (m < n) m = n;

                Random tGenerator = new Random(Seed);

                int kse = n - 3; // number of split edge operations
                int kae = m - n; // number of add edge operations
                List<int[]> tEdges = new List<int[]>();
                List<int>   tNodes = new List<int>();
                List<int> fNodes = new List<int>();
                

            for (int i = 0; i < n; i++)
                        fNodes.Add(i);

            for (int i = 0; i < 3; i++) {

                lSelectNode[i] = fNodes[tGenerator.Next() % fNodes.Count];
                fNodes.Remove(lSelectNode[i]);
            }



            tEdges.Add(new int[2] { lSelectNode[0], lSelectNode[1] });
            tEdges.Add(new int[2] { lSelectNode[1], lSelectNode[2] });
            tEdges.Add(new int[2] { lSelectNode[2], lSelectNode[0] });

            int choice;
            int[] cEdge;
            int sEdge;
            int cNode;
            int sNode;

            int ci, cj;

            while (kse + kae > 0) {

                choice = tGenerator.Next() % (kse + kae);

                if (choice <= kse)
                {

                    sEdge = tGenerator.Next() % tEdges.Count();
                    cEdge = tEdges[sEdge];
                    tEdges.RemoveAt(sEdge);

                    cNode = fNodes[tGenerator.Next() % fNodes.Count];
                    fNodes.Remove(cNode);

                    tEdges.Add(new int[2] { cEdge[0], cNode });
                    tEdges.Add(new int[2] { cEdge[1], cNode });
                    kse--;

                }
                else {
                    ci = fNodes[tGenerator.Next() % fNodes.Count];
                    fNodes.Remove(ci);

                    cj = fNodes[tGenerator.Next() % fNodes.Count];
                    fNodes.Remove(cj);

                    tEdges.Add(new int[2] { ci, cj });
                    kae--;
                }
            }



            mNumberOfVertices = n;
            CreateEdgeArray();
            foreach (int[] ce in tEdges) {

                AddEdge(ce[0], ce[1]); 

            }
         
        }
        
                    
        public bool EdgeExists(int i, int j)
        {
            return mEdges[i].Contains(j);
        }

        public List<int> GetConnections(int Index)
        {


            return mEdges[Index];


        }
        public void RemoveConnections(int Index)
        {
            // FIX NUMBER OF EDGES
            foreach (int c in mEdges[Index])
            {
                mEdges[c].Remove(Index);
            }
            mEdges[Index].Clear();


        }

       public void AddEdge(int a, int b)
        {


            if ((b >= 0) && (b < NumberOfVertices) && (a >= 0) && (a < NumberOfVertices))
            {

                if (!EdgeExists(a, b))
                {
                    mEdges[a].Add(b);
                    if(a!= b)
                        mEdges[b].Add(a);
                    mNumberOfEdges++;

                }
             
            }
        }

        public ABSGraph GetRenumerateGraph(int[] nIndex) {

            ABSGraph rABSGraph = new ABSGraph(mNumberOfVertices);

            for (int i = 0; i < mNumberOfVertices; i++) {
                foreach (int e in mEdges[i]) {

                    rABSGraph.AddEdge(nIndex[i], nIndex[e]);
                }
            }

            return rABSGraph;
        }

        public ABSGraph GetSubGraphGraph(List<int> sIndex)
        {

            ABSGraph rABSGraph = new ABSGraph(sIndex.Count());
            int tIndex;
            for (int i = 0; i < sIndex.Count; i++)
            {
                foreach (int e in mEdges[sIndex[i]])
                {
                    tIndex = sIndex.FindIndex(x => x == e);
                    if (tIndex != -1)
                        rABSGraph.AddEdge(i, tIndex);
                }

            }
            return rABSGraph;
        }
        public void GenerateUnitDisc(Kord[] Kords, double R, int nNumberOfVertex) {

            mNumberOfVertices = nNumberOfVertex;
            mNumberOfEdges = 0;

            mEdges = new List<int>[mNumberOfVertices];
            CreateEdgeArray();

            for (int i = 0; i < mNumberOfVertices; i++)
                for (int j = i + 1; j < mNumberOfVertices; j++)
                {
                    if (Kord.Distance(Kords[i], Kords[j]) < R)
                        AddEdge(i, j);
                }

        }

        public void Save(String FileName)
        {

            System.IO.StreamWriter File = new StreamWriter(FileName);
            Save(File);

            File.Close();

        }
        public void Save(System.IO.StreamWriter File)
        {
            int counter = 0;
            File.WriteLine("Number Of Vertices");
            File.WriteLine(mNumberOfVertices);

            File.WriteLine("Edges");

            foreach (List<int> l in mEdges)
            {

                File.WriteLine("Number edges containting node " + counter++);
                File.WriteLine(l.Count);
                File.WriteLine("list ");

                foreach (int a in l)
                {
                    File.WriteLine(a);
                }

            }

        }


        public void Load(System.IO.StreamReader File)
        {
            int counter = 0;
            int cNumberOfEdges;
            int cNode;
            String temp;
            //"Number Of Vertices";
            temp = File.ReadLine();
            temp = File.ReadLine();
            mNumberOfVertices = Convert.ToInt16(temp);

            CreateEdgeArray();

            //Edges
            temp = File.ReadLine();

            for (int i = 0; i < mNumberOfVertices; i++) {
                temp = File.ReadLine();
                temp = File.ReadLine();

                cNumberOfEdges = Convert.ToInt16(temp);
                temp = File.ReadLine();
                counter = 0;
                while (counter < cNumberOfEdges) {

                    temp =  File.ReadLine();
                    cNode = Convert.ToInt32(temp);

                    AddEdge(i, cNode);
                    counter++;
                }


            }
        }


        public void Load(String FileName)
        {


            System.IO.StreamReader File = new StreamReader(FileName);

            Load(File);

            File.Close();
        }


        public void LoadPowerMat(System.IO.StreamReader File)
        {
            int counter = 0;
            int cNumberOfEdges;
            int cNode;
            string temp;
            string tempA;
            string tempB;
            int A;
            int B;
            string[] words;
            char[] delimiterChars = { ' ', ',', '.', ':', '\t' };

            //"Number Of Vertices";
            temp = File.ReadLine();
            mNumberOfVertices = Convert.ToInt16(temp);

            CreateEdgeArray();

            while (!File.EndOfStream)
            {
                
                tempA = File.ReadLine();

                words = tempA.Split(delimiterChars);
               
                A =  Convert.ToInt32(words[0]);
                B = Convert.ToInt32(words[1]);

                AddEdge(A, B);
            }
            

            /*

            //Edges
            temp = File.ReadLine();

            for (int i = 0; i < mNumberOfVertices; i++)
            {
                temp = File.ReadLine();
                temp = File.ReadLine();

                cNumberOfEdges = Convert.ToInt16(temp);
                temp = File.ReadLine();
                counter = 0;
                while (counter < cNumberOfEdges)
                {

                    temp = File.ReadLine();
                    cNode = Convert.ToInt32(temp);

                    AddEdge(i, cNode);
                    counter++;
                }


            }
            */
        }


        public void LoadPowerMat(String FileName)
        {


            System.IO.StreamReader File = new StreamReader(FileName);

            LoadPowerMat(File);

            File.Close();
        }
    }
}
