﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace HamiltoninaGSD
{
    public class Circle{

        public  Kord mCenter;
        public  double mR;
        public static bool Overlap(Circle A, Circle B) { return Kord.Distance(A.mCenter, B.mCenter) <= Math.Abs(A.mR + B.mR); }

        public Circle(Kord iCenter, double iR) { mCenter = new Kord(iCenter); mR = iR;}
        
    }


    public class ABSGraphGenerator
    {
        static public void GeneratePlainDistance(out ABSGraph oGraph, out ABSGraphVisualiser vGraph, int iNumberOfVertex, double PlainW, double PlainH, double R,  Random iGenerator) {

            Circle[] gCircles = new Circle[iNumberOfVertex];
            Kord tCenter = new Kord(); 
            

            oGraph = null;
            vGraph = null;

            oGraph = new ABSGraph(iNumberOfVertex);
            vGraph = new ABSGraphVisualiser(oGraph);
            for (int i = 0; i < iNumberOfVertex; i++) {

                tCenter.mX = iGenerator.NextDouble() * PlainW;
                tCenter.mY = iGenerator.NextDouble() * PlainH;

                gCircles[i] = new Circle(tCenter, R);
                vGraph.SetVertexCord(tCenter, i);
                
            }

            for (int i = 0; i < iNumberOfVertex; i++)
                for (int j = 0; j < iNumberOfVertex; j++) {

                    if (Circle.Overlap(gCircles[i], gCircles[j]) && (!oGraph.EdgeExists(i,j)))
                                oGraph.AddEdge(i, j);
                }

        }
   

    static public void GeneratePlainDistanceMinDist(out ABSGraph oGraph, out ABSGraphVisualiser vGraph, int iNumberOfVertex, double PlainW, double PlainH, double R, double MinDist, Random iGenerator)
    {

        Circle[]   gCircles = new Circle[iNumberOfVertex];
        Circle[]   tCircles = new Circle[iNumberOfVertex];

            Kord tCenter = new Kord();
        bool           canFit;
            int         Counter;

        oGraph = null;
        vGraph = null;

        oGraph = new ABSGraph(iNumberOfVertex);
        vGraph = new ABSGraphVisualiser(oGraph);

            Counter = 0;

            tCenter.mX = iGenerator.NextDouble() * PlainW;
            tCenter.mY = iGenerator.NextDouble() * PlainH;
            tCircles[Counter] = new Circle(tCenter, MinDist);
            gCircles[Counter] = new Circle(tCenter, R);
            vGraph.SetVertexCord(tCenter, Counter);
            Counter = 1;

            while (Counter< iNumberOfVertex)
        {

         
            tCenter.mX = iGenerator.NextDouble() * PlainW;
            tCenter.mY = iGenerator.NextDouble() * PlainH;

            tCircles[Counter] = new Circle(tCenter, MinDist);

                canFit = true;
                    for (int i = 0; i < Counter; i++) {

                    
                        if (Circle.Overlap(tCircles[i], tCircles[Counter]))
                        {
                            canFit = false;
                            break;
                        }
                    }

                

                if (canFit)
                {
                    gCircles[Counter] = new Circle(tCenter, R);
                    vGraph.SetVertexCord(tCenter, Counter);
                    Counter++;
                }

        }

        for (int i = 0; i < iNumberOfVertex; i++)
            for (int j = 0; j < iNumberOfVertex; j++)
            {

                if ((Circle.Overlap(gCircles[i], gCircles[j]) && (!oGraph.EdgeExists(i, j)) ) )
                    oGraph.AddEdge(i, j);
            }

    }


        static public void GeneratePlainDistanceMinDistTF(out ABSGraph oGraph, out ABSGraphVisualiser vGraph, int iNumberOfVertex, double PlainW, double PlainH, double R, double MinDist, Random iGenerator)
        {

            Circle[] gCircles = new Circle[iNumberOfVertex];
            Circle[] tCircles = new Circle[iNumberOfVertex];

            Kord tCenter = new Kord();
            bool canFit;
            int Counter;

            oGraph = null;
            vGraph = null;

            oGraph = new ABSGraph(iNumberOfVertex);
            vGraph = new ABSGraphVisualiser(oGraph);

            Counter = 0;

            tCenter.mX = iGenerator.NextDouble() * PlainW;
            tCenter.mY = iGenerator.NextDouble() * PlainH;
            tCircles[Counter] = new Circle(tCenter, MinDist);
            gCircles[Counter] = new Circle(tCenter, R);
            vGraph.SetVertexCord(tCenter, Counter);
            Counter = 1;

            while (Counter < iNumberOfVertex)
            {


                switch (Counter) {
                    case 1:
                        tCenter.mX = iGenerator.NextDouble() * PlainW*0.05;
                        tCenter.mY = iGenerator.NextDouble() * PlainH ;
                        break;
                    case 2:
                        tCenter.mX = iGenerator.NextDouble() * PlainW * 0.05 + PlainW * 0.9;
                        tCenter.mY = iGenerator.NextDouble() * PlainH ;
                        break;
                    case 3:
                        tCenter.mX = iGenerator.NextDouble() * PlainW;
                        tCenter.mY = iGenerator.NextDouble() * PlainH * 0.05 + PlainH * 0.9;
                        break;
                    case 4:
                        tCenter.mX = iGenerator.NextDouble() * PlainW;
                        tCenter.mY = iGenerator.NextDouble() * PlainH * 0.05;
                        break;

                    default:
                        tCenter.mX = iGenerator.NextDouble() * PlainW;
                        tCenter.mY = iGenerator.NextDouble() * PlainH;
                        break;
                }

                tCircles[Counter] = new Circle(tCenter, MinDist);

                canFit = true;
                for (int i = 0; i < Counter; i++)
                {


                    if (Circle.Overlap(tCircles[i], tCircles[Counter]))
                    {
                        canFit = false;
                        break;
                    }
                }



                if (canFit)
                {
                    gCircles[Counter] = new Circle(tCenter, R);
                    vGraph.SetVertexCord(tCenter, Counter);
                    Counter++;
                }

            }

            for (int i = 0; i < iNumberOfVertex; i++)
                for (int j = 0; j < iNumberOfVertex; j++)
                {

                    if ((Circle.Overlap(gCircles[i], gCircles[j]) && (!oGraph.EdgeExists(i, j))))
                        oGraph.AddEdge(i, j);
                }

        }




    }



}
