﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;


using System;
using System.IO;
using System.IO;
using System.Drawing;
using System.Drawing.Drawing2D;


namespace HamiltoninaGSD
{
    public class Kord
    {
        public double mX;
        public double mY;
       
        public Kord(double nX, double nY) { mX = nX; mY = nY; }
        public Kord(Kord A) { mX = A.mX; mY = A.mY; }

        public Kord() { mX = 0; mY = 0; }
        static public double Distance(Kord A, Kord B) { return Math.Sqrt((A.mX - B.mX) * (A.mX - B.mX) + (A.mY - B.mY) * (A.mY - B.mY)); }

    }
    

    public class ABSGraphVisualiser
    {
        protected System.Drawing.Bitmap      mBitmap;
        public int                       mScreenX;
        public int                       mScreenY;
        protected Graphics                  mScreen;
        protected int                       mCounter;
        protected int                       mFontSize;
        protected int                       mNodeSize;
        protected int                       mCut;
    //    protected bool mShowSelected;

        public  Kord[]                     mVertexPositions;
        public ABSGraph                   mGraph;



        protected int mBaseR;
        protected int mBaseG;
        protected int mBaseB;

        protected int mSelectedIndex;

        public int GetSelected() { return mSelectedIndex; }


        public void SetRGB(int iR, int iG, int iB)
        {

            mBaseB = iB;
            mBaseG = iG;
            mBaseR = iR;
        }

        public List<Kord> GetCordList(List<int> Selected) {

            List<Kord> Result = new List<Kord>();

            foreach (int s in Selected) {

                Result.Add(new Kord(mVertexPositions[s]));
            }

            return Result;
        }
        public void SetBitMap(System.Drawing.Bitmap iBitmap) {

            mBitmap = iBitmap;
        }
        public void Select(int sX, int sY)
        {
            double minDist = double.MaxValue;
            double cDist = 0;

//            Kord A = new Kord(sX - mCut, sY - mCut );
            Kord A = new Kord(sX , sY);
            mSelectedIndex = -1;
            for (int i = 0; i < mGraph.NumberOfVertices; i++)
            {
                cDist = Kord.Distance(A, mVertexPositions[i]);

                if (cDist < minDist)
                {
                    mSelectedIndex = i;
                    minDist = cDist;

                }

            }


        }

        public void SetGraph(ABSGraph A) {
            mGraph = A;
        }
        public ABSGraphVisualiser(ABSGraph A) {
            Init(A);

        }

       
        public void Init(ABSGraph A) {
            mGraph = A;
            mVertexPositions = new Kord[A.NumberOfVertices];

            mBitmap = null;
            mScreenX = 1;
            mScreenY = 1;

            mFontSize = 10;
            mCounter = 0;
            mNodeSize = 10;
            mCut = 50;


            mBaseB = 0;
            mBaseG = 0;
            mBaseR = 255;

        }

        public ABSGraphVisualiser(ABSGraphVisualiser A)
        {
            Init(A.mGraph);
            

            mVertexPositions = new Kord[A.mGraph.NumberOfVertices];
            mScreenX = A.mScreenX;
            mScreenY = A.mScreenY;
            for (int i = 0; i < mGraph.NumberOfVertices; i++) {

                mVertexPositions[i] = new Kord(A.mVertexPositions[i]);
            }
        }

        public void SetVertexCord(Kord iPos, int index) { mVertexPositions[index] = new Kord(iPos); }
        public void SetVertexCord(double iX, double iY, int index) { mVertexPositions[index] = new Kord(iX, iY); }
        public void ScaleAll(double ScaleX, double ScaleY) {

            
            for (int i = 0; i < mGraph.NumberOfVertices; i++) {
                mVertexPositions[i].mX *= ScaleX;
                mVertexPositions[i].mY *= ScaleY;

            }
        }

        public void InitScreen(int SizeX, int SizeY)
        {
            double ScaleX = SizeX / mScreenX;
            double ScaleY = SizeY / mScreenY;

            mScreenX = SizeX;
            mScreenY = SizeY;
            mBitmap = new Bitmap(mScreenX, mScreenY);
            mFontSize = 16;
            mCounter = 0;
            mNodeSize = 5;
            ScaleAll(ScaleX, ScaleY);

        }

        public void SetScreen(Graphics nScreen, int iCut = 50, System.Drawing.Bitmap iBitmap = null
            )
        {
            int mCut = iCut;
            double ScaleX = (nScreen.VisibleClipBounds.Width- mCut) / mScreenX;
            double ScaleY = (nScreen.VisibleClipBounds.Height- mCut) / mScreenY;


            mScreenX = Convert.ToInt16(nScreen.VisibleClipBounds.Width - mCut);
            mScreenY = Convert.ToInt16(nScreen.VisibleClipBounds.Height - mCut);

            ScaleAll(ScaleX, ScaleY);

            if (iBitmap == null)
                mBitmap = new Bitmap(mScreenX + mCut, mScreenY + mCut);
            else
                mBitmap = iBitmap;
            mScreen = nScreen;
//            InitPositions();
//            GeneratePositions();

        }



        
        public virtual void DrawTest(System.Drawing.Graphics tGraphics, bool clear = true)
        {

            

            if(clear)
                tGraphics.Clear(Color.White);
            DrawEdges(tGraphics);
//            DrawPartitioningEdges(tGraphics);

            DrawNodes(tGraphics);
//            DrawPartitioning(tGraphics);
//            mScreen.DrawImage(mBitmap, 0, 0);
    //        tGraphics.Dispose();


        }

        public virtual void DrawTest( bool clear = true)
        {

            System.Drawing.Graphics tGraphics = Graphics.FromImage(mBitmap);

            DrawTest(tGraphics, clear);

            


        }


       


        public virtual  void DrawNode(int index, Color mColor, System.Drawing.Graphics tGraphics)
        {


            Font drawFont = new Font("Arial", mFontSize);
            SolidBrush drawBrush = new SolidBrush(Color.Black);
            SolidBrush fontBrush = new SolidBrush(Color.Black);
            string s;
            
            SizeF stringSize;
            SolidBrush nodeBrush = new SolidBrush(mColor);
            Pen nodePen = new Pen(nodeBrush, 3);


            //            if(mGraph.IsArticulationPoint(index))
            //
            drawBrush = new SolidBrush(Color.Black);

            //            RSubGraphNodeArray Temp = mPartitioning.GetSubgraphNodeArray();
            //            s = Convert.ToString(mGraph.GetWeight(i));
            //            if (Temp != null)
            //            {
            //                if (mGraph.GetWeight(i) < 0)
            //                    s += "T" + Temp.GetSubgraphNode(i).TreeConnect;
            //            }

            //            stringSize = tGraphics.MeasureString(s, drawFont);

            //            for (int i = 0; i < mGraph.NumberOfVertices; i++) {
            tGraphics.FillRectangle(drawBrush, new Rectangle((int )mVertexPositions[index].mX , (int )mVertexPositions[index].mY , mNodeSize, mNodeSize));
            //            tGraphics.DrawRectangle(drawBrush, new Rectangle((int)mVertexPositions[index].mX, (int)mVertexPositions[index].mY, mNodeSize, mNodeSize));
            //          tGraphics.FillRectangle(drawBrush, new Rectangle((int)mVertexPositions[index].mX, (int)mVertexPositions[index].mY, mNodeSize, mNodeSize));

            //            tGraphics.FillRectangle(drawBrush, new Rectangle(mVertexPositions[i].mX, mVertexPositions[i].mY, mNodeSize, mNodeSize));
            //
            //            tGraphics.DrawString(s, drawFont, fontBrush, mVertexPositions[i].mX, mVertexPositions[i].mY);
            s = "";
/*            if (mShowDFS)
                s = Convert.ToString(mGraph.GetDFS(index));
            if (mShowDFSParent)
                s += "/"+ Convert.ToString(mGraph.GetDFSParent(index));
            if (mShowDFSLow)
                s += "/" + Convert.ToString(mGraph.GetDFSLow(index));
                */

            tGraphics.DrawString(s, drawFont, fontBrush, (float)mVertexPositions[index].mX, (float)mVertexPositions[index].mY);



    }

        public void DrawNodes(System.Drawing.Graphics tGraphics) {

            for (int i = 0; i < mGraph.NumberOfVertices; i++)
            {
                    DrawNode(i, Color.Black,tGraphics);
            }

        }


        public void DrawEdge(int i, int j, Color ccolor, System.Drawing.Graphics tGraphics, int iWidth = 3)
        {



            SolidBrush nodeBrush = new SolidBrush(ccolor);
            Pen nodePen = new Pen(nodeBrush, iWidth);

            tGraphics.DrawLine(nodePen, (int)(mVertexPositions[i].mX + mNodeSize / 2), (int)(mVertexPositions[i].mY + mNodeSize / 2),
                                                (int)(mVertexPositions[j].mX + mNodeSize / 2), (int)(mVertexPositions[j].mY + mNodeSize / 2));


        }
        public void DrawEdges(System.Drawing.Graphics tGraphics)
        {


            Font drawFont = new Font("Arial", mFontSize);
            SolidBrush drawBrush = new SolidBrush(Color.Black);
            SolidBrush currentBrush = new SolidBrush(Color.FromArgb(mBaseR, mBaseG, mBaseB));


            SolidBrush nodeBrush = new SolidBrush(Color.Black);
            Pen nodePen = new Pen(nodeBrush, 3);


            string s;
//            mNodeSize = 50;


            SizeF stringSize;

            for (int i = 0; i < mGraph.NumberOfVertices; i++)
                for (int j = i + 1; j < mGraph.NumberOfVertices; j++)
                    if (mGraph.EdgeExists(i, j))
                    {

                        DrawEdge(i, j, Color.LightGray, tGraphics);
                        /*    tGraphics.DrawLine(nodePen, mVertexPositions[i].mX + mNodeSize / 2, mVertexPositions[i].mY + mNodeSize / 2,
                                                        mVertexPositions[j].mX + mNodeSize / 2, mVertexPositions[j].mY + mNodeSize / 2);
                         * */
                    }

            nodePen.Brush = currentBrush;

            drawBrush.Dispose();
            drawFont.Dispose();
            nodePen.Dispose();
            nodeBrush.Dispose();



        }


    }
}
