﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace HamiltoninaGSD
{
    public class BFSEar
    {
        List<int>       mDescendants;
        List<int>       mNodes;
        int[]           mParentNodes;
        int[]           mParentEars;

        int mId;
        static int      StaticCounter;

        public void InitCounter() { StaticCounter = 0; }
        public BFSEar() {

            //            mDescendants  = new List<int>();
//            mNodes = new List<int>();
            mDescendants = null;
            mNodes = null;

            mParentNodes = new int[2];
            mParentEars = new int[2];

            mParentNodes[0]   = -1;
            mParentNodes[1]   = -1;
            mParentEars[0] = -1;
            mParentEars[1] = -1;

            mId = BFSEar.StaticCounter++;
        }

        public BFSEar(BFSNode S, BFSNode E, List<int> iNodes )
        {

            //mDescendants = new List<int>();
            mDescendants = null;
            mNodes = new List<int>(iNodes);


            mParentNodes = new int[2];
            mParentEars = new int[2];

            mParentNodes[0] = S.Index;
            mParentNodes[1] = E.Index;
            mParentEars[0] = S.EarIndex;
            mParentEars[1] = E.EarIndex;

            mId = BFSEar.StaticCounter++;
        }

        public BFSEar(BFSEar A)
        {
            //            if(A.mDescendants.Count >0)
            //                mDescendants= new List<int>(mDescendants);
            //            else
            if (A.Descendants != null)
                mDescendants = new List<int>(A.mDescendants);
            else
                mDescendants = null;

            mNodes = new List<int>(A.mNodes);
            mParentNodes = new int[2];
            mParentNodes[0] = A.mParentNodes[0];
            mParentNodes[1] = A.mParentNodes[1];

            mParentEars = new int[2];
            mParentEars[0] = A.mParentEars[0];
            mParentEars[1] = A.mParentEars[1];
            mId = A.mId;
        }

        public int[] ParentEars {
            get { return mParentEars; }  
        }
        public void AddDescendant(int EarID) {
            if (mDescendants == null)
                mDescendants = new List<int>();
            mDescendants.Add(EarID);
                
        }

        public int Id {

            get { return mId; }
            set { mId = value; }
        }
        public List<int> Descendants
        {

            get { return mDescendants; }
            set { mDescendants = value; }
        }

        public List<int> Nodes
        {

            get { return mNodes; }
            set { mNodes = value; }
        }
        public void SetParentNodes(int start, int end) {

            mParentNodes[0] = start;
            mParentNodes[1] = end;
        }
        public void SetParentEars(int start, int end)
        {

            mParentNodes[0] = start;
            mParentNodes[1] = end;
        }

        public int NumberOfDescendants()
        {
            return mDescendants.Count;
        }
       


    }
}
