﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace HamiltoninaGSD
{
    public class BFSEarContainer
    {
        List<BFSEar> mEars;
//        BFSGraph     mGraph;


        public void SetGraph(ABSGraph A) { }
        public BFSEarContainer()
        {
            mEars = new List<BFSEar>();
        }
        public List<BFSEar> Ears {
            get { return mEars; }
        }
       public  BFSEar GetEar(int EarId ) {

            foreach (BFSEar ear in mEars) {

                if (ear.Id == EarId)
                    return ear;
            }

            return null;

        }
        public void Add(List<int> iNodes, BFSGraph iGraph) {
            BFSEar nEar;

            int s = iGraph.GetNode(iNodes[0]).EarIndex;
            int e = iGraph.GetNode(iNodes.Last()).EarIndex;

            nEar = new BFSEar(iGraph.GetNode(iNodes[0]), iGraph.GetNode(iNodes.Last()), iNodes);
            mEars.Add(nEar);
            AddDescendant(nEar.ParentEars[0], nEar.Id);
//            if(nEar.ParentEars[0] != nEar.ParentEars[1])
                    AddDescendant(nEar.ParentEars[1], nEar.Id);

        }

        public void Add(BFSEar iEar)
        {
            BFSEar nEar;

//            int s = mGraph.GetNode(iNodes[0]).EarIndex;
//            int e = mGraph.GetNode(iNodes.Last()).EarIndex;

            nEar = new BFSEar(iEar);
            mEars.Add(nEar);
            AddDescendant(nEar.ParentEars[0], nEar.Id);
            AddDescendant(nEar.ParentEars[1], nEar.Id);

        }


        void AddDescendant(int EarIndex, int DescendantIndex) {

            foreach (BFSEar tEar in mEars) {
                if (tEar.Id == EarIndex) {
                    tEar.AddDescendant(DescendantIndex);
                    break;
                }
            }
        }


        public void RemoveEar(int rId)
        {
            List<BFSEar> nList = new List<BFSEar>();
            BFSEar sEar = null;
            foreach (BFSEar nEar in mEars) {
                if (nEar.Id != rId)
                {

                    nList.Add(nEar);
                }
                else {
                    sEar = nEar;
                }



            }
            
            BFSEar pEar;
            if (sEar != null)
            {
                pEar = GetEar(sEar.ParentEars[0]);
                if (pEar != null)
                    pEar.Descendants.Remove(sEar.Id);

                pEar = GetEar(sEar.ParentEars[1]);
                if (pEar != null)
                    pEar.Descendants.Remove(sEar.Id);

            }
            mEars = nList;

        }
        public BFSEar GetLastEar() {

            return mEars[mEars.Count - 1];
        }



    }
}
