﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;


using System;
using System.IO;
using System.IO;
using System.Drawing;
using System.Drawing.Drawing2D;

namespace HamiltoninaGSD
{
    public class BFSGraphVisualiser : ABSGraphVisualiser
    {


        protected bool mShowBFS;
        protected bool mShowBFSDistance;
        protected bool mShowBFSParent;
        protected bool mShowBFSTreeRoot;
        protected bool mShowSelected;



        public BFSGraphVisualiser(ABSGraph A): base(A)
        {
            mShowBFS = true;
            mShowBFSParent = true;
            mShowBFSDistance = true;
            mShowSelected = true;

        }
        public BFSGraphVisualiser(ABSGraphVisualiser A) : base(A)
        {

            mShowBFS = true;
            mShowBFSParent = true;
            mShowBFSDistance = true;
            mShowBFSTreeRoot = true;
            mShowSelected = true;

        }
        public void DrawTree(int index, Color iColor, System.Drawing.Graphics tGraphics) {

            List<int> Descendats;
            Descendats = ((BFSGraph)mGraph).GetDescendants(index);
            foreach (int v in Descendats) {

                DrawEdge(index, v, iColor, tGraphics,6);
                DrawTree(v,  iColor, tGraphics);
            }

        }


        public void DrawEars( Color iColor, System.Drawing.Graphics tGraphics)
        {

//            List<List<int>> tEars;
            List<BFSEar> tEars;
            int a, b;
            tEars = ((BFSGraph)mGraph).GetEars().Ears;
            foreach (BFSEar tEar in tEars)
            {
                for (int i = 0; i < tEar.Nodes.Count - 1; i++) {
                    if(tEar.Descendants.Count>0)
                        DrawEdge(tEar.Nodes[i], tEar.Nodes[i+1], iColor, tGraphics, 1);
                    else
                        DrawEdge(tEar.Nodes[i], tEar.Nodes[i + 1], iColor, tGraphics, 3);
                }


            }

        }


        public override void DrawNode(int index, Color mColor, System.Drawing.Graphics tGraphics)
        {


            Font drawFont = new Font("Arial", mFontSize);
            SolidBrush drawBrush = new SolidBrush(Color.Black);
//            SolidBrush drawBrush = new SolidBrush(Color.FromArgb(mBaseR/2, mBaseG / 2, mBaseB / 2));
            SolidBrush currentBrush = new SolidBrush(Color.Pink);
            SolidBrush FinishedBrush = new SolidBrush(Color.Beige);
            SolidBrush fontBrush = new SolidBrush(Color.Black);
            string s;

            SizeF stringSize;
            SolidBrush nodeBrush = new SolidBrush(mColor);
            Pen nodePen = new Pen(nodeBrush, 3);


            if (((BFSGraph)mGraph).IsInCycle(index))
                drawBrush = new SolidBrush(Color.FromArgb(mBaseR,   mBaseG,  mBaseB ));


            //            if (((DFSGraph)mGraph).IsArticulationPoint(index))
            //                            drawBrush = new SolidBrush(Color.Red);

            //            RSubGraphNodeArray Temp = mPartitioning.GetSubgraphNodeArray();
            //            s = Convert.ToString(mGraph.GetWeight(i));
            //            if (Temp != null)
            //            {
            //                if (mGraph.GetWeight(i) < 0)
            //                    s += "T" + Temp.GetSubgraphNode(i).TreeConnect;
            //            }

            //            stringSize = tGraphics.MeasureString(s, drawFont);

            //            for (int i = 0; i < mGraph.NumberOfVertices; i++) {

            //            if (((BFSGraph)mGraph).IsCurrent(index))
            //                tGraphics.FillRectangle(currentBrush, new Rectangle((int)mVertexPositions[index].mX-5, (int)mVertexPositions[index].mY-5, mNodeSize+10, mNodeSize+10));

            if (((BFSGraph)mGraph).IsFinished(index))
                tGraphics.FillRectangle(FinishedBrush, new Rectangle((int)mVertexPositions[index].mX - 6, (int)mVertexPositions[index].mY - 6, mNodeSize + 12, mNodeSize + 12));


            if (((BFSGraph)mGraph).IsLastUsed(index))
                tGraphics.FillRectangle(currentBrush, new Rectangle((int)mVertexPositions[index].mX - 5, (int)mVertexPositions[index].mY - 5, mNodeSize + 10, mNodeSize + 10));


            tGraphics.FillRectangle(drawBrush, new Rectangle((int)mVertexPositions[index].mX, (int)mVertexPositions[index].mY, mNodeSize, mNodeSize));
            //            tGraphics.DrawRectangle(drawBrush, new Rectangle((int)mVertexPositions[index].mX, (int)mVertexPositions[index].mY, mNodeSize, mNodeSize));
            //          tGraphics.FillRectangle(drawBrush, new Rectangle((int)mVertexPositions[index].mX, (int)mVertexPositions[index].mY, mNodeSize, mNodeSize));

            //            tGraphics.FillRectangle(drawBrush, new Rectangle(mVertexPositions[i].mX, mVertexPositions[i].mY, mNodeSize, mNodeSize));
            //
            //            tGraphics.DrawString(s, drawFont, fontBrush, mVertexPositions[i].mX, mVertexPositions[i].mY);
            s = "";

            if (((BFSGraph)mGraph).Root == index)
                fontBrush = new SolidBrush(Color.Red);

            s = Convert.ToString(index);
            if (mShowBFS)
                  s += "/"+Convert.ToString(((BFSGraph)mGraph).GetBFS(index));
            if (mShowBFSDistance)
                s += "/" + Convert.ToString(((BFSGraph)mGraph).GetBFSDistance(index));
            if (mShowBFSParent)
                s += "/" + Convert.ToString(((BFSGraph)mGraph).GetBFSParent(index));
            if (mShowBFSTreeRoot)
                s += "/" + Convert.ToString(((BFSGraph)mGraph).GetBFSTreeRoot(index));
                

            tGraphics.DrawString(s, drawFont, fontBrush, (float)mVertexPositions[index].mX, (float)mVertexPositions[index].mY);



        }
        public void DrawSelected(System.Drawing.Graphics tGraphics)
        {

            SolidBrush FinishedBrush = new SolidBrush(Color.Gold);

         



         

            if((mShowSelected)&& (mSelectedIndex!= -1))
                tGraphics.FillRectangle(FinishedBrush, new Rectangle((int)mVertexPositions[mSelectedIndex].mX - 10, (int)mVertexPositions[mSelectedIndex].mY - 10, mNodeSize + 20, mNodeSize + 20));
}

        public override void DrawTest(System.Drawing.Graphics tGraphics, bool clear = true) {


            if (clear)
                tGraphics.Clear(Color.White);
            DrawEdges(tGraphics);
            //            DrawPartitioningEdges(tGraphics);
            DrawSelected(tGraphics);
            DrawTree(((BFSGraph)mGraph).Root, Color.FromArgb((int)(mBaseR * 0.25) + 180, (int)(int)(mBaseG * 0.25) + 180, (int)(int)(mBaseB * 0.25) + 180), tGraphics);
            DrawEars(Color.FromArgb((int)(mBaseR * 0.1) + 200, (int)(mBaseG * 0.5) + 100, (int)(mBaseB * 0.1) + 200), tGraphics);


            DrawNodes(tGraphics);
            //            DrawPartitioning(tGraphics);
      //      mScreen.DrawImage(mBitmap, 0, 0);
            //            tGraphics.Dispose();

        }

        public override void DrawTest(bool clear = true)
        {

            System.Drawing.Graphics tGraphics = Graphics.FromImage(mBitmap);
            DrawTest(tGraphics, clear);

            /*
                         tGraphics.Clear(Color.White);
                         DrawContainerBay(tGraphics);
                         mScreen.DrawImage(mBitmap, 0, 0);
                         tGraphics.Dispose();
             * 
            */
/*
            if (clear)
                tGraphics.Clear(Color.White);
            DrawEdges(tGraphics);
            //            DrawPartitioningEdges(tGraphics);
            DrawSelected(tGraphics);
            DrawTree(((BFSGraph)mGraph).Root, Color.FromArgb((int)(mBaseR * 0.25)+ 180, (int)(int)(mBaseG * 0.25) + 180, (int)(int)(mBaseB * 0.25) + 180),  tGraphics);
            DrawEars(Color.FromArgb((int)(mBaseR * 0.1) + 200, (int)(mBaseG * 0.5)+100, (int)(mBaseB * 0.1) + 200), tGraphics);

            
                DrawNodes(tGraphics);
            //            DrawPartitioning(tGraphics);
            mScreen.DrawImage(mBitmap, 0, 0);
//            tGraphics.Dispose();

    */
        }
    }
}
