﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace HamiltoninaGSD
{
    /*
    enum CycleStepResult
    {
        AddedNode, CompletedCycle, Failed, Continue
    }
    */
   
    public class BFSNode
    {


        protected int mIndex;
        protected int mDistance;
        protected int mBFSParent;
        protected int mBFSCounter;
        protected int mBFSTreeRoot;
        protected int mBFSTreeRootParent;
        protected bool mFinished;
        protected bool mAvailable;
        protected bool mInCycle;
        protected int mEarIndex;

        protected List<int> mBFSDescendants;


//        protected fixed int[1000] mBFSDescendants;

        //        protected int     mBFSDescendants;
        //        int               mNumberOfDescendants;





        public List<int> BFSDescendants
        {

            get { return mBFSDescendants; }
            set { mBFSDescendants = value; }
        }


        public bool BFSInCycle
        {

            get { return mInCycle; }
            set { mInCycle = value; }
        }


        public bool BFSFinished
        {

            get { return mFinished; }
            set { mFinished = value; }
        }

        public bool BFSAvailable
        {

            get { return mAvailable; }
            set { mAvailable = value; }
        }



        public int Index
        {

            get { return mIndex; }
            set { mIndex = value; }
        }

        public int EarIndex
        {

            get { return mEarIndex; }
            set { mEarIndex = value; }
        }

        public int BFSCounter
        {

            get { return mBFSCounter; }
            set { mBFSCounter = value; }
        }
        public int BFSTreeRoot
        {

            get { return mBFSTreeRoot; }
            set { mBFSTreeRoot = value; }
        }
        public int BFSTreeRootParent
        {

            get { return mBFSTreeRootParent; }
            set { mBFSTreeRootParent = value; }
        }


        public int BFSDistance
        {

            get { return mDistance; }
            set { mDistance = value; }
        }
        public int BFSParent
        {

            get { return mBFSParent; }
            set { mBFSParent = value; }
        }

        public BFSNode(BFSNode A, bool All = true)
        {

            mIndex = A.mIndex;
            mDistance = A.mDistance;
            mBFSParent = A.mBFSParent;
            mBFSCounter = A.mBFSCounter;
            mInCycle = A.mInCycle;
            mAvailable = A.mAvailable;
            mFinished = A.mFinished;
            mBFSTreeRoot = A.mBFSTreeRoot;
            mEarIndex = A.mEarIndex;
            mBFSTreeRootParent = A.mBFSTreeRootParent;

//            mBFSDescendants = new List<int>();

//            mBFSDescendants = new List<int>(A.BFSDescendants);

            mBFSDescendants = null;
            /*
            foreach (int desc in A.BFSDescendants)
            {

                mBFSDescendants.Add(desc);
            }
            */

      }
         public BFSNode(int nIndex)
         {

             mIndex = nIndex;
             mDistance = -1;
             mBFSParent = -1;
             mBFSCounter = -1;
             mInCycle = false;
             mAvailable = true;
             mFinished = false;
             mBFSTreeRoot = -1;
             mEarIndex = -1;
//             mBFSDescendants = new List<int>();
            mBFSDescendants = null;
        }

        public BFSNode()
         {

             mIndex = -1;
             mDistance = -1;
             mBFSParent = -1;
             mBFSCounter = -1;
             mInCycle = false;
             mAvailable = true;
             mFinished = false;
             mBFSTreeRoot = -1;
             mEarIndex = -1;
             mBFSDescendants = new List<int>();
         }



         public BFSNode(int nIndex, int nBFSIndex, int nDistance)
         {

             mIndex = nIndex;
             mDistance = nDistance;
             mBFSParent = -1;
             mBFSCounter = nBFSIndex;
         }

         public BFSNode(int Index, int nBFSIndex, int Distance, int nParent)
         {

             mIndex = Index;
             mDistance = Distance;
             mBFSParent = nParent;
             mBFSCounter = nBFSIndex;
         }

     }


 
 /*
    public struct BFSNode
    {


        public int Index;
        public int BFSDistance;
        public int BFSParent;
        public int BFSCounter;
        public int BFSTreeRoot;
        public int BFSTreeRootParent;
        public bool BFSFinished;
        public bool BFSAvailable;
        public bool BFSInCycle;
        public int EarIndex;

        public List<int> BFSDescendants;


        //        protected fixed int[1000] mBFSDescendants;

        //        protected int     mBFSDescendants;
        //        int               mNumberOfDescendants;



/*

        public List<int> BFSDescendants
        {

            get { return mBFSDescendants; }
            set { mBFSDescendants = value; }
        }


        public bool BFSInCycle
        {

            get { return mInCycle; }
            set { mInCycle = value; }
        }


        public bool BFSFinished
        {

            get { return mFinished; }
            set { mFinished = value; }
        }

        public bool BFSAvailable
        {

            get { return mAvailable; }
            set { mAvailable = value; }
        }



        public int Index
        {

            get { return mIndex; }
            set { mIndex = value; }
        }

        public int EarIndex
        {

            get { return mEarIndex; }
            set { mEarIndex = value; }
        }

        public int BFSCounter
        {

            get { return mBFSCounter; }
            set { mBFSCounter = value; }
        }
        public int BFSTreeRoot
        {

            get { return mBFSTreeRoot; }
            set { mBFSTreeRoot = value; }
        }
        public int BFSTreeRootParent
        {

            get { return mBFSTreeRootParent; }
            set { mBFSTreeRootParent = value; }
        }


        public int BFSDistance
        {

            get { return mDistance; }
            set { mDistance = value; }
        }
        public int BFSParent
        {

            get { return mBFSParent; }
            set { mBFSParent = value; }
        }
        */
     /*   public BFSNode(BFSNode A, bool All = true)
        {

            Index = A.Index;
            BFSDistance = A.BFSDistance;
            BFSParent = A.BFSParent;
            BFSCounter = A.BFSCounter;
            BFSInCycle = A.BFSInCycle;
            BFSAvailable = A.BFSAvailable;
            BFSFinished = A.BFSFinished;
            BFSTreeRoot = A.BFSTreeRoot;
            EarIndex = A.EarIndex;
            BFSTreeRootParent = A.BFSTreeRootParent;

            //            mBFSDescendants = new List<int>();

            //            mBFSDescendants = new List<int>(A.BFSDescendants);

            BFSDescendants = null;
           

         }
                 public BFSNode(int nIndex)
                 {

                     Index = nIndex;
                     BFSDistance = -1;
                     BFSParent = -1;
                     BFSCounter = -1;
                     BFSInCycle = false;
                     BFSAvailable = true;
                     BFSFinished = false;
                     BFSTreeRoot = -1;
                     EarIndex = -1;
                     BFSDescendants = new List<int>();
                    BFSTreeRootParent = -1;
                 }

          

                 public BFSNode(int nIndex, int nBFSIndex, int nDistance)
                 {

                     Index = nIndex;
                     BFSDistance = nDistance;
                     BFSParent = -1;
                     BFSCounter = nBFSIndex;


                     BFSInCycle = false;
                     BFSAvailable = true;
                     BFSFinished = false;
                     BFSTreeRoot = -1;
                     EarIndex = -1;
                     BFSDescendants = new List<int>();
                     BFSTreeRootParent = -1;
                }

                 public BFSNode(int nIndex, int nBFSIndex, int nDistance, int nParent)
                 {

                     Index = nIndex;
                    BFSDistance = nDistance;
                     BFSParent = nParent;
                     BFSCounter = nBFSIndex;

            BFSInCycle = false;
            BFSAvailable = true;
            BFSFinished = false;
            BFSTreeRoot = -1;
            EarIndex = -1;
            BFSDescendants = new List<int>();
            BFSTreeRootParent = -1;

        }

    }
    */

         

        }
