﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;


using System;
using System.IO;
using System.IO;
using System.Drawing;
using System.Drawing.Drawing2D;


namespace HamiltoninaGSD
{
    class DFSGraphVisualiser: ABSGraphVisualiser
    {

        protected bool mShowDFS;
        protected bool mShowDFSParent;
        protected bool mShowDFSLow;


        public DFSGraphVisualiser(ABSGraph A): base(A)
        {
            mShowDFS = true;
            mShowDFSParent = true;
            mShowDFSLow = true;

        }
        public DFSGraphVisualiser(ABSGraphVisualiser A) : base(A)
        {
            mShowDFS = true;
            mShowDFSParent = true;
            mShowDFSLow = true;

        }


        public override void DrawNode(int index, Color mColor, System.Drawing.Graphics tGraphics)
        {


            Font drawFont = new Font("Arial", mFontSize);
            SolidBrush drawBrush = new SolidBrush(Color.Black);
            SolidBrush fontBrush = new SolidBrush(Color.Black);
            string s;

            SizeF stringSize;
            SolidBrush nodeBrush = new SolidBrush(mColor);
            Pen nodePen = new Pen(nodeBrush, 3);


            if (((DFSGraph)mGraph).IsArticulationPoint(index))
                drawBrush = new SolidBrush(Color.Red);

            //            RSubGraphNodeArray Temp = mPartitioning.GetSubgraphNodeArray();
            //            s = Convert.ToString(mGraph.GetWeight(i));
            //            if (Temp != null)
            //            {
            //                if (mGraph.GetWeight(i) < 0)
            //                    s += "T" + Temp.GetSubgraphNode(i).TreeConnect;
            //            }

            //            stringSize = tGraphics.MeasureString(s, drawFont);

            //            for (int i = 0; i < mGraph.NumberOfVertices; i++) {
            tGraphics.FillRectangle(drawBrush, new Rectangle((int)mVertexPositions[index].mX, (int)mVertexPositions[index].mY, mNodeSize, mNodeSize));
            //            tGraphics.DrawRectangle(drawBrush, new Rectangle((int)mVertexPositions[index].mX, (int)mVertexPositions[index].mY, mNodeSize, mNodeSize));
            //          tGraphics.FillRectangle(drawBrush, new Rectangle((int)mVertexPositions[index].mX, (int)mVertexPositions[index].mY, mNodeSize, mNodeSize));

            //            tGraphics.FillRectangle(drawBrush, new Rectangle(mVertexPositions[i].mX, mVertexPositions[i].mY, mNodeSize, mNodeSize));
            //
            //            tGraphics.DrawString(s, drawFont, fontBrush, mVertexPositions[i].mX, mVertexPositions[i].mY);
            s = "";
            if (mShowDFS)
                s = Convert.ToString(((DFSGraph)mGraph).GetDFS(index));
            if (mShowDFSParent)
                s += "/" + Convert.ToString(((DFSGraph)mGraph).GetDFSParent(index));
            if (mShowDFSLow)
                s += "/" + Convert.ToString(((DFSGraph)mGraph).GetDFSLow(index));


            tGraphics.DrawString(s, drawFont, fontBrush, (float)mVertexPositions[index].mX, (float)mVertexPositions[index].mY);



        }
    }
}
