﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace HamiltoninaGSD
{
    class DFSGraph: ABSGraph
    {

        protected int[] mDFSCounter;
        protected int[] mDFSParent;
        protected bool[] mArticulationPoint;

        protected int[] mDFSLow;
        protected int mCounter;


        public int GetDFS(int index) { return mDFSCounter[index]; }
        public int GetDFSParent(int index) { return mDFSParent[index]; }
        public int GetDFSLow(int index) { return mDFSLow[index]; }
        public bool IsArticulationPoint(int index) { return mArticulationPoint[index]; }


        public DFSGraph(int nNumberOfVertex) : base(nNumberOfVertex){


        }
        public DFSGraph(ABSGraph A):base(A)
        {

        }

        public void InitDFSCounter()
        {

            mDFSCounter = Enumerable.Repeat(-1, mNumberOfVertices).ToArray();
            mDFSParent = Enumerable.Repeat(-1, mNumberOfVertices).ToArray();
            mDFSLow = Enumerable.Repeat(-1, mNumberOfVertices).ToArray();
            mArticulationPoint = new bool[mNumberOfVertices];

            for (int i = 0; i < mNumberOfVertices; i++)
                mArticulationPoint[i] = false;
            mCounter = 1;

            CalcDFSIndex();
        }

        public void CalcDFSIndex(int root = 0)
        {

            int k = 0;
            int children = 0; ;

            mDFSCounter[root] = mCounter++;
            mDFSLow[root] = mDFSCounter[root];
            foreach (int des in mEdges[root])
            {
                if (mDFSCounter[des] == -1)
                {
                    children++;
                    mDFSParent[des] = mDFSCounter[root];
                    CalcDFSIndex(des);
                    mDFSLow[root] = Math.Min(mDFSLow[root], mDFSLow[des]);
                    if ((mDFSLow[des] >= mDFSCounter[root]) && (1 != mDFSCounter[root]))
                        mArticulationPoint[root] = true;

                    if ((1 == mDFSCounter[root]) && (children > 1))
                        mArticulationPoint[root] = true;

                }
                else
                {

                    if ((mDFSParent[root] != mDFSCounter[des]))
                        mDFSLow[root] = Math.Min(mDFSLow[root], mDFSCounter[des]);

                }
            }
            //        foreach (int des in mEdges[root]) {

            //                if ((mDFSLow[root] > mDFSLow[des]) && (mDFSLow[des] != -1))
            //                    mDFSLow[root] = mDFSLow[des];
            //            }

        }
    }
}
