﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace HamiltoninaGSD
{
    class ProblemGenerator
    {
        ABSGraph OriginalGraph;
        public BipartitioningVisualiser mVisualiser;
        Random mGenerator;
        public ABSBipartitioning mPartitioning;
        int mSeed;
        public BipartitioningProblem mProblem;


        public void GenerateProblemMatPower(string FileName) {


        }
        public List<Kord> GenerateBiConnectedGraph(int NumberOFNodes, int InitialNumberOfNodes, double RConnect, double RFree, double boxSX, double boxSY, int nSeed, out ABSGraph tGraph)
        {




            OriginalGraph = new DFSGraph(10);
//            ABSGraph tGraph;
            ABSGraphVisualiser tVisualiser;
            int NumberOfNodes = 500;
            //            mProblem = new BipartitioningProblem();

            BFSNodeContainer.InitStatic(NumberOfNodes);
            mGenerator = new Random(nSeed);



            ABSGraphGenerator.GeneratePlainDistanceMinDistTF(out tGraph, out tVisualiser, InitialNumberOfNodes, boxSX, boxSY, RConnect, RFree, mGenerator);


            OriginalGraph = new BFSGraph(tGraph);


            mProblem = new BipartitioningProblem(tGraph, 1);

            mProblem.NumberOfSubgraphs = 1;
            mProblem.MaxNodesInSubgraph = NumberOFNodes;
            mProblem.SetAllMaxNodesInCycle();
            mProblem.SetGraph(OriginalGraph);
            mProblem.Start();
            mProblem.NewGenerator(18);
            mProblem.NumberOfGeneratedSolutions = 0;

            mProblem.FindSolution(1);


            mPartitioning = mProblem.Partitioning;

            mVisualiser = new BipartitioningVisualiser(tVisualiser);

            List<int> BiNodes = mPartitioning.GetSubgraph(0).GetNodesInCycles();
            //            ABSGraph   BiSub    = mProblem.Partitioning.GetGraph().GetSubGraphGraph(BiNodes);
            List<Kord> Result = tVisualiser.GetCordList(BiNodes);

            return Result;
        }
        bool IsInSideBox(double X, double Y, Kord MinBox, Kord MaxBox, double Dx, double Dy)
        {


            if (MinBox.mX > X + Dx)
                return false;
            if (MinBox.mY > Y + Dy)
                return false;
            if (MaxBox.mX < X - Dx)
                return false;
            if (MaxBox.mY < Y - Dy)
                return false;

            return true;

        }
        public int MaxNewExtraEdges(List<int> oldExtra, List<int> newExtraEdges) {
            int Max = int.MinValue;
            int cExtra;

            for (int i = 0; i < oldExtra.Count; i++) {

                cExtra = oldExtra[i] + newExtraEdges[i];
                if (Max < cExtra)
                    Max = cExtra;
            }

            return Max;

        }
        public int NumberOfNewConnections(double offsetX, double OffsetY, List<Kord> iBicon, List<List<Kord>> Existing, double R, out int oNeighborSub, out List<int> ExtraEdges) {

            int Result = 0;
            int cExtra = 0;
            List<Kord> cBicon = new List<Kord>();
            List<int> nSub = new List<int>();
            int cSub = 0;

            for(int j = 0; j < iBicon.Count; j++)
            {
                cBicon.Add(new Kord(iBicon[j].mX + offsetX, iBicon[j].mY + OffsetY));
                
            }

            ExtraEdges = new List<int>();

            foreach (List<Kord> l in Existing)
            {
                cExtra = 0;
                foreach (Kord tn in cBicon)
                {

                    foreach (Kord te in l)
                    {
                        if (Kord.Distance(tn, te) < R)
                        {
                            Result++;
                            cExtra++;
                            if (!nSub.Contains(cSub))
                            {
                                nSub.Add(cSub);
                               
                            }

                        }
                    }
                }
                ExtraEdges.Add(cExtra);
                cSub++;
            
                
            }

            oNeighborSub = nSub.Count;

            return Result;
        }


        /*
        public List<List<Kord>> GenerateProblemInstanceList(int NumberOfSubgraphs, int NumberOfNodesInSubgraph, double RConnect, double RFree, double boxSX, double boxSY, int nSeed)
        {
            List<List<Kord>> tProblem = new List<List<Kord>>();
            List<Kord> cBicon;
            double tBoxSX;
            double tBoxSY;
            double sizeBox = 1;
            double OptSizeX = Math.Sqrt(1 * sizeBox) * boxSX / Math.Sqrt(NumberOfSubgraphs);
            double OptSizeY = Math.Sqrt(1 * sizeBox) * boxSY / Math.Sqrt(NumberOfSubgraphs);
            Random tGenerator = new Random(nSeed);
            double MaxX, MinX;
            double MaxY, MinY;
            double offsetX, offsetY;
            Kord[,] bBox = new Kord[NumberOfSubgraphs, 2];

            int CountInside;
            bool AddSub;
            double BoxW;
            double BoxH;
            int MM;
            int counter;
            int select;
            bool NoAdd;
            double coef = 0.3;
            int MaxConnect;
            int nNeighborSub;
            double r;
            //            Random tGenerator = new Random(nSeed);
            coef =5 / (double)NumberOfNodesInSubgraph;
         for (int i = 0; i < NumberOfSubgraphs; i++)
            {
               
                bBox[i, 0] = new Kord();
                bBox[i, 1] = new Kord();

           //     r = 0.3 + 2* tGenerator.NextDouble();
//                OptSizeX = Math.Sqrt(sizeBox) * boxSX / Math.Sqrt(NumberOfSubgraphs) / r;
//                OptSizeY = Math.Sqrt(sizeBox) * boxSY / Math.Sqrt(NumberOfSubgraphs)*r;

                cBicon = GenerateBiConnectedGraph(NumberOfNodesInSubgraph, (int)( NumberOfNodesInSubgraph * sizeBox), RConnect, RFree, OptSizeX, OptSizeY, tGenerator.Next());
         //       coef = 0.3;
                while (cBicon.Count() < NumberOfNodesInSubgraph)
                {
//                    r = 0.3 + 2*mGenerator.NextDouble();
//                    OptSizeX = Math.Sqrt(sizeBox) * boxSX / Math.Sqrt(NumberOfSubgraphs) / r;
//                    OptSizeY = Math.Sqrt(sizeBox) * boxSY / Math.Sqrt(NumberOfSubgraphs) * r;

                    cBicon = GenerateBiConnectedGraph(NumberOfNodesInSubgraph, (int)(NumberOfNodesInSubgraph * sizeBox), RConnect, RFree, OptSizeX, OptSizeY, tGenerator.Next());
                }




                   MaxX = double.MinValue;
                    MinX = double.MaxValue;

                    MaxY = double.MinValue;
                    MinY = double.MaxValue;

                    foreach (Kord a in cBicon)
                    {
                        if (a.mX < MinX)
                            MinX = a.mX;
                        if (a.mX > MaxX)
                            MaxX = a.mX;

                        if (a.mY < MinY)
                            MinY = a.mY;
                        if (a.mY > MaxY)
                            MaxY = a.mY;

                    }

                    bBox[tProblem.Count, 0].mX = MinX;
                    bBox[tProblem.Count, 0].mY = MinY;


                    bBox[tProblem.Count, 1].mX = MaxX;
                    bBox[tProblem.Count, 1].mY = MaxY;

                    AddSub = false;

                    offsetX = -MinX + (boxSX - (MaxX - MinX)) * tGenerator.NextDouble();
                    offsetY = -MinY + (boxSY - (MaxY - MinY)) * tGenerator.NextDouble();

                    counter = 0;



                    BoxW = MaxX - MinX;
                    BoxH = MaxY - MinY;
    

                AddSub = false;

                offsetX = -MinX + (boxSX - (MaxX - MinX)) * tGenerator.NextDouble();
                offsetY = -MinY + (boxSY - (MaxY - MinY)) * tGenerator.NextDouble();

                counter = 0;
                int cNumberOfNewConnections;
                NoAdd = false;
                
                while (!AddSub)
                {
                    counter++;
                    MaxConnect = (int)Math.Max(5, coef * NumberOfNodesInSubgraph); 
                    offsetX = -MinX + (boxSX - BoxW) * tGenerator.NextDouble();
                    offsetY = -MinY + (boxSY - BoxH) * tGenerator.NextDouble();
                    cNumberOfNewConnections = NumberOfNewConnections(offsetX, offsetY, cBicon, tProblem, 2 * RConnect, out nNeighborSub);

                    if (((cNumberOfNewConnections >= 3) && (cNumberOfNewConnections <= MaxConnect)) || (tProblem.Count == 0))
                    {
                        
                        counter = 0;
//                        if((mGenerator.NextDouble()> Math.Pow(1/(double)nNeighborSub,2)) || (tProblem.Count == 0))
                            AddSub = true;
                    }

                    if ((counter > 10000)&&(!AddSub)) { 
                        NoAdd = true;
                        coef *= 1.5;
                     }

                    CountInside = 1;
           
                }


                for (int j = 0; j < cBicon.Count; j++)
                {
                    cBicon[j].mX = cBicon[j].mX + offsetX;
                    cBicon[j].mY = cBicon[j].mY + offsetY;

                    if (cBicon[j].mY > 1)
                        MM = 1;
                    if (cBicon[j].mY < 0)
                        MM = 1;

                    if (cBicon[j].mX > 1)
                        MM = 1;
                    if (cBicon[j].mX < 0)
                        MM = 1;
                }

                bBox[tProblem.Count, 0].mX = MinX + offsetX;
                bBox[tProblem.Count, 0].mY = MinY + offsetY;


                bBox[tProblem.Count, 1].mX = MaxX + offsetX;
                bBox[tProblem.Count, 1].mY = MaxY + offsetY;

                if (!NoAdd)
                {
                    tProblem.Add(cBicon);
                    coef = 5 / (double)NumberOfNodesInSubgraph;
                }
                else
                    i--;
            }

            return tProblem;
        }

        */

        public void TranslateTo00(List<Kord> cBicon) {
            double MinX = double.MaxValue;
            double MinY = double.MaxValue;


            double MaxX = double.MinValue;
            double MaxY = double.MinValue;

            foreach (Kord a in cBicon)
            {
                if (a.mX < MinX)
                    MinX = a.mX;
                if (a.mX > MaxX)
                    MaxX = a.mX;

                if (a.mY < MinY)
                    MinY = a.mY;
                if (a.mY > MaxY)
                    MaxY = a.mY;

            }

            // set c bicon to [0, Max-Min]
            foreach (Kord a in cBicon)
            {
                a.mX -= MinX;
                a.mY -= MinY;
            }



        }

        
        public  void GetMax(List<Kord> cBicon, out double MaxX, out double MaxY)
        {

             MaxX = double.MinValue;
             MaxY = double.MinValue;

            foreach (Kord a in cBicon)
            {
                if (a.mX > MaxX)
                    MaxX = a.mX;
                if (a.mY > MaxY)
                    MaxY = a.mY;

            }
        }
        public List<List<Kord>> GenerateProblemInstanceList(int NumberOfSubgraphs, int NumberOfNodesInSubgraph, double RConnect, double RFree, double boxSX, double boxSY, int nSeed)
        {
            List<List<Kord>> tProblem = new List<List<Kord>>();
            List<int>  ExtraEdges = new List<int>();
            List<int>  cExtraEdges = new List<int>();
            List<int>  minExtraEdges = new List<int>();


            List<Kord> cBicon;

            double sizeBox = 1;
            int bCounter;

            double tX, tY;
//            double oOptSizeX = Math.Sqrt(1.1 * sizeBox) * boxSX / Math.Sqrt(NumberOfSubgraphs);
//            double oOptSizeY = Math.Sqrt(1.1 * sizeBox) * boxSY / Math.Sqrt(NumberOfSubgraphs);
            double oOptSizeX = Math.Sqrt(1.1 * sizeBox) * boxSX / Math.Sqrt(NumberOfSubgraphs);
            double oOptSizeY = Math.Sqrt(1.1 * sizeBox) * boxSY / Math.Sqrt(NumberOfSubgraphs);

            double OptSizeX;
            double OptSizeY;

            Random tGenerator = new Random(nSeed);
            double MaxX, MinX;
            double MaxY, MinY;

            double AllMaxX  = double.MinValue;
            double AllMaxY = double.MinValue;

            double offsetX, offsetY;
            double MinOffsetX=0, MinOffsetY=0;

            bool AddSub;
            double BoxW;
            double BoxH;
            int counter;
            bool NoAdd;
            double coefMax = 0.3;
            double coefMin = 0.1;
            int MaxConnect, MinConnect;
            int nNeighborSub;
            ABSGraph cGraph = null;
         double ExtraCoef = 1.1;

            double r = 0.25 + tGenerator.NextDouble()*0.75;

            int cMin;
            int cMinMaxExtraEdges;
            int MaxExtraEdges;
            int MinMaxExtraEdges;

            double cMaxX, cMaxY;

            bool More;
            coefMax = 0.6;
            coefMin = 0.2;

            //   OptSizeX *= r;
            //            OptSizeY *= 1/r;
            cMin = int.MaxValue;
            cBicon = null;
            for (int i = 0; i < NumberOfSubgraphs; i++)
            {
                More = true;
                while (More) {
                    r = 0.5 + tGenerator.NextDouble() * 0.5;
                    if (tGenerator.Next() % 2 == 0)
                    {
                        r = 1 / r;
                    }
                    if (NumberOfNodesInSubgraph ==5)
                                 r = 1;

                    OptSizeX = oOptSizeX * r;
                    OptSizeY = oOptSizeY * 1 / r;
                        

                    cMin = int.MaxValue;

                    cBicon = GenerateBiConnectedGraph(NumberOfNodesInSubgraph, (int)(NumberOfNodesInSubgraph * sizeBox * ExtraCoef), RConnect, RFree, OptSizeX, OptSizeY, tGenerator.Next(), out cGraph);

                    bCounter = 0;


                    while ((cBicon.Count() < NumberOfNodesInSubgraph) && (bCounter < 10))
                    {
                        cBicon = GenerateBiConnectedGraph(NumberOfNodesInSubgraph, (int)(NumberOfNodesInSubgraph * sizeBox* ExtraCoef), RConnect, RFree, OptSizeX, OptSizeY, tGenerator.Next(), out cGraph);
                        bCounter++;
                    }

                    More = false;
                    if (cBicon.Count() < NumberOfNodesInSubgraph)
                        More = true;
              }
            
                TranslateTo00(cBicon);
                GetMax(cBicon, out MaxX, out MaxY);


                counter = 0;
                AddSub = false;
                counter = 0;
                int cNumberOfNewConnections;
                NoAdd = false;
                cNumberOfNewConnections = 0;
                MinMaxExtraEdges = int.MaxValue;
                while (!AddSub)
                {
                    counter++;
//                    MaxConnect = (int)Math.Max(5, coefMax * NumberOfNodesInSubgraph);
//                    MinConnect = (int)Math.Max(3, coefMin * NumberOfNodesInSubgraph);

                    MaxConnect = (int)Math.Max(5, coefMax * cGraph.NumberOfEdges);
                    MinConnect = (int)Math.Max(3, coefMin * cGraph.NumberOfEdges);


                    if (tProblem.Count != 0)
                    {

                        //    All --- 
                        //    Box xxxxxxxx  
                        //    Box - All = cc
                        //    cc---cc
                        //    nB  iii


                        offsetX = (AllMaxX - boxSX) + (AllMaxX + 2*(boxSX - AllMaxX)-MaxX) * tGenerator.NextDouble();
                        offsetY = (AllMaxY - boxSY) + (AllMaxY + 2*(boxSY - AllMaxY)-MaxY) * tGenerator.NextDouble();
                    }
                    else
                    {

                        offsetX = 0;
                        offsetY = 0;

                    }


              



                    cNumberOfNewConnections = NumberOfNewConnections(offsetX, offsetY, cBicon, tProblem, 2 * RConnect, out nNeighborSub, out cExtraEdges);
                    cMinMaxExtraEdges = Math.Max(MaxNewExtraEdges(ExtraEdges, cExtraEdges), cNumberOfNewConnections);
//                    if ( ((cMin > cNumberOfNewConnections) &&(cNumberOfNewConnections>0)&&(cNumberOfNewConnections >= MinConnect))
//                        || ((cMin == cNumberOfNewConnections) && (cNumberOfNewConnections > 0) && (MinMaxExtraEdges> cMinMaxExtraEdges))
//                        )
                        if ((cNumberOfNewConnections >= MinConnect)&&(MinMaxExtraEdges > cMinMaxExtraEdges)
//                            || ((cMin == cNumberOfNewConnections) && (cNumberOfNewConnections > 0) && (MinMaxExtraEdges > cMinMaxExtraEdges))
                            )
                        {
                            cMin = cNumberOfNewConnections;
                        MinOffsetX = offsetX;
                        MinOffsetY = offsetY;
                        minExtraEdges = cExtraEdges;
                        MinMaxExtraEdges = cMinMaxExtraEdges;

                    }
//                  if (((cNumberOfNewConnections >= MinConnect) && (cNumberOfNewConnections <= MaxConnect) ) || (tProblem.Count == 0))
                    //                    if (((cNumberOfNewConnections >= MinConnect) && (cNumberOfNewConnections <= MaxConnect) && (cMinMaxExtraEdges<20)) || (tProblem.Count == 0))
                        if ((tProblem.Count == 0))
                    {

                        counter = 0;
                        //                        if((mGenerator.NextDouble()> Math.Pow(1/(double)nNeighborSub,2)) || (tProblem.Count == 0))
                        AddSub = true;

                        MinOffsetX = offsetX;
                        MinOffsetY = offsetY;
                        minExtraEdges = cExtraEdges;
                        cMin = cNumberOfNewConnections;

                    }

                    if ((counter > 1000) && (!AddSub))
                    {

                        AddSub = true;

//                        NoAdd = true;
//                        coef *= 1.5;
                    }
                    /*          */

                }


                for (int j = 0; j < cBicon.Count; j++)
                {
                    cBicon[j].mX = cBicon[j].mX + MinOffsetX;
                    cBicon[j].mY = cBicon[j].mY + MinOffsetY;
                }

                

           //     if (!NoAdd)
//                {   
                    tProblem.Add(cBicon);
                if (tProblem.Count == 1)
                    ExtraEdges.Add(0);
                else
                {
                    ExtraEdges.Add(cMin);
                    for (int ic = 0; ic < tProblem.Count - 1; ic++)
                        ExtraEdges[ic] += minExtraEdges[ic];
                }


                if (MinOffsetX < 0)
                        tX = -MinOffsetX;
                    else
                        tX = 0;

                    if (MinOffsetY < 0)
                        tY = -MinOffsetY;
                    else
                        tY = 0;

                    AllMaxX = double.MinValue;
                    AllMaxY = double.MinValue;
                    foreach (List<Kord> l in tProblem) {
                        foreach (Kord a in l)
                        {
                            a.mX += tX;
                            a.mY += tY;
                        }

                        GetMax(l, out cMaxX, out cMaxY);
                        if (AllMaxX < cMaxX)
                            AllMaxX = cMaxX;
                        if (AllMaxY < cMaxY)
                            AllMaxY = cMaxY;

                    }

                    //coef = 5 / (double)NumberOfNodesInSubgraph;
  //              }
   //             else
 //                   i--;
            }

            return tProblem;
        }

        public void GenerateProblemInstance(int NumberOfSubgraphs, int NumberOfNodesInSubgraph, double RConnect, double RFree, double boxSX, double boxSY, int nSeed,
            out ProblemInstance oProblem)
        {

            List<List<Kord>> Partitions = GenerateProblemInstanceList(NumberOfSubgraphs, NumberOfNodesInSubgraph, RConnect, RFree, boxSX, boxSY, nSeed);

            List<List<int>>  PartitionsIndex = new List<List<int>>();
            Kord[]           NewKordIndex = new Kord[NumberOfSubgraphs* NumberOfNodesInSubgraph];
//            List<List<int>>  NewPartitionIndex = new Kord[NumberOfSubgraphs * NumberOfNodesInSubgraph];

            int[]            gRoots = new int[NumberOfSubgraphs];

            List<int>        FreeIndex = new List<int>();
            Random           Generator= new Random(nSeed);
            int              iSelected;
            int              Selected;

            int iRoot;
            int cSubGraphCounter;
            List<int>        cSubgraphIndex;

            for (int i = 0; i < NumberOfSubgraphs * NumberOfNodesInSubgraph; i++) {
                FreeIndex.Add(i);
            }

            cSubGraphCounter = 0;
            foreach (List<Kord> l in Partitions) {

                iSelected = mGenerator.Next() % FreeIndex.Count();
                Selected = FreeIndex[iSelected];
                cSubgraphIndex = new List<int>();
                iRoot = mGenerator.Next() % l.Count();

                gRoots[cSubGraphCounter] = Selected;
                NewKordIndex[Selected] = l[iRoot];
                cSubgraphIndex.Add(Selected);
        //        l.Remove(l[0]);
                FreeIndex.Remove(Selected);
                

                for (int i = 0; i < l.Count; i++) {

                    if (i != iRoot)
                    {
                        iSelected = mGenerator.Next() % FreeIndex.Count();
                        Selected = FreeIndex[iSelected];

                        NewKordIndex[Selected] = l[i];
                        cSubgraphIndex.Add(Selected);
                        FreeIndex.Remove(Selected);
                    }
                }
                cSubGraphCounter++;
                PartitionsIndex.Add(cSubgraphIndex);





            }
            ABSGraph tGraph = new ABSGraph(NumberOfSubgraphs * NumberOfNodesInSubgraph);
            for (int i = 0; i < NumberOfSubgraphs * NumberOfNodesInSubgraph; i++)
                for (int j = i + 1; j < NumberOfSubgraphs * NumberOfNodesInSubgraph; j++)
                {
                    if (Kord.Distance(NewKordIndex[i], NewKordIndex[j]) < 2 * RConnect)
                        tGraph.AddEdge(i, j);
                }


            oProblem = new ProblemInstance(NewKordIndex, PartitionsIndex, gRoots, NumberOfSubgraphs, NumberOfNodesInSubgraph, 2*RConnect);

           

        }

        
    }

    }



